/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Parameter print command
 *  File        : mhparam.c
 *  Version     : 2.19
 *  First Edit  : 1995-04/23
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
struct option	option[] = {		/* ץ		*/
  {"help",		0},
  {"all",		0},
  {"component",		0},
  {"nocomponent",	0},
};
static char		mhparam_opt[SMALL_BUFF];
static struct cpy_hdr	mhparam_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {"mhparamopt:",	mhparam_opt,	sizeof(mhparam_opt)},
};

static int	print_component();		/* ѥ᡼ɽ	*/

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  FILE		*fp;
  int		status;
  int		i, j;
  int		a_flag = 0;
  int		c_flag = -1;
  int		component = 0;
  char		*ptr, *ptr2;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }

  /*
   * ե졼
   */

  if (get_environ(mhparam_option, sizeof(mhparam_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }

  /*
   * åβ
   */

  ptr2 = mhparam_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    usage(prog_name, "[components] [switches]",
		  option, sizeof(option) / sizeof(struct option));
	    exit(0);
	    break;
	  case 1:	/* -all		*/
	    a_flag = 1;
	    break;
	  case 2:	/* -components	*/
	    c_flag = 1;
	    break;
	  case 3:	/* -nocomponents*/
	    c_flag = 0;
	    break;
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    } else if (*ptr) {
      component++;
    }
  }
  if (a_flag) {
    if (c_flag != -1) {
      print_fatal("-%scomponents ignored with -all", c_flag ? "" : "no");
    }
    c_flag = 1;
    component = 0;
  } else if (!component) {
    exit(0);
  }
  if (c_flag == -1) {
    if (component == 1) {
      c_flag = 0;
    }
  }
  if (!(fp = open_init_file())) {
    exit(1);
  }
  status = 0;
  if (component) {
    for (i = 1; i < argc; i++) {
      ptr = argv[i];
      if ((*ptr != '-') && (*ptr != '/')) {
	if (print_component(fp, ptr, c_flag)) {
	  status = 1;
	}
      }
    }
  } else {
    print_component(fp, (char*)NULL, c_flag);
  }
  fclose(fp);
  exit(status);
}

/*
 * ѥ᡼ɽ
 */

static int	print_component(fp, component, c_flag)
     FILE	*fp;
     char	*component;
     int	c_flag;
{
  char	buff[BUFF_SIZE];
  char	*ptr;
  int	status;

  status = 1;
  fseek(fp, 0L, 0);
  while (fgets(buff, sizeof(buff), fp)) {
    ptr = buff;
    while (*ptr) {
      if ((*ptr == '\n') || (*ptr == '\r')) {
	*ptr = '\0';
	break;
      } else {
	ptr++;
      }
    }
    ptr = buff;
    if (component) {
      if (strncasecmp(buff, component, strlen(component))) {
	continue;
      }
      ptr = &buff[strlen(component)];
      if (!*ptr) {
	continue;
      }
      while ((*ptr == ' ') || (*ptr == '\t')) {
	*ptr++ = '\0';
      }
    } else {
      while (*ptr) {
	if ((*ptr == ' ') || (*ptr == '\t')) {
	  *ptr++ = '\0';
	  while ((*ptr == ' ') || (*ptr == '\t')) {
	    ptr++;
	  }
	} else if (*ptr ==':') {
	  break;
	} else {
	  ptr++;
	}
      }
    }
    if (*ptr != ':') {
      continue;
    }
    *ptr++ = '\0';
    while ((*ptr == ' ') || (*ptr == '\t')) {
      ptr++;
    }
    if (c_flag) {
      printf("%s:\t%s\n", component ? component : buff, ptr);
    } else {
      printf("%s\n", ptr);
    }
    status = 0;
    if (component) {
      break;
    }
  }
  return(status);
}
