/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Common define
 *  File        : mmh.h
 *  Version     : 2.20
 *  First Edit  : 1994-05/14
 *  Last  Edit  : 1997-12/23
 *  Author      :  
 *
 */

#include	"field.h"

#define	MMH_VERSION		"2.20"
#define	MMH_AUTHOR		"A.Takuma"
#define	MMH_DATE		"1997-12/23(Tue)"

#define	LF			0x0a

#define	ALIAS_BUFF		(1024 * 4)
#define	MAX_MESSAGES		256
#define	ALLOC_NUMBER		256

#ifdef	__FreeBSD__
#define	MH_SPOOL_PATH		"/var/mail"
#else	/* !__FreeBSD__ */
#define	MH_SPOOL_PATH		"/usr/spool/mail"
#endif	/* !__FreeBSD__ */
#define	MH_DEFAULT_PATH		"Mail"
#define	MH_DEFAULT_FOLDER	"inbox"
#define	MH_PACK_FILE		"msgbox"
#define	MH_DEFAULT_PAGER	"less"

#if	defined(MSDOS) && !defined(USE_LONG_FNAME)
#ifdef	X68K
#define	MH_INIT_FILE		"_mh_profile"
#define	MH_SEQ_FILE		"_mh_sequences"
#else	/* !X68K */
#define	MH_INIT_FILE		"_mh_prof"
#define	MH_SEQ_FILE		"_mh_sequ"
#endif	/* !X68K */
#else	/* !MSDOS || USE_LONG_FNAME */
#define	MH_INIT_FILE		".mh_profile"
#define	MH_SEQ_FILE		".mh_sequences"
#endif	/* !MSDOS || USE_LONG_FNAME */

#define	MH_CONTEXT_FILE		"context"
#define	MH_PATH_FIELD		"Path:"
#define	MH_DEFAULT_FIELD	"Default-Folder:"
#define	MH_CONTEXT_FIELD	"Current-Folder:"
#define	MH_STACK_FIELD		"Folder-Stack:"
#define	MH_F_PERM_FIELD		"Folder-Protect:"
#define	MH_M_PERM_FIELD		"Msg-Protect:"
#define	MH_ALIAS_FIELD		"Aliasfile:"
#define	MH_CURRENT_FIELD	"cur:"

#define	SPOOL_HEADER		"From "
#define	PACK_HEADER		"\001\001\001\001"	/* ^A^A^A^A */

#define	MH_ALL_PARAM		"all"
#define	MH_FIRST_PARAM		"first"
#define	MH_LAST_PARAM		"last"
#define	MH_PREV_PARAM		"prev"
#define	MH_NEXT_PARAM		"next"
#define	MH_CUR_PARAM		"cur"
#define	MH_NEW_PARAM		"new"

#define	FOLDERS_COMMAND		"folders"
#define	PREV_COMMAND		"prev"
#define	NEXT_COMMAND		"next"

#define	HOME_ENV		"HOME"
#define	USER_ENV		"USER"
#define	PAGER_ENV		"PAGER"
#ifdef	MSDOS
#ifdef	X68K
#define	TMPDIR_ENV		"temp"
#else	/* !X68K */
#define	TMPDIR_ENV		"TEMP"
#endif	/* !X68K */
#else	/* !MSDOS */
#define	TMPDIR_ENV		"TMPDIR"
#endif	/* !MSDOS */
#define	UNKNOWN_USER		"nobody"
#ifdef	MSDOS
#define	DEFAULT_TMP		"."
#else	/* !MSDOS */
#define	DEFAULT_TMP		"/tmp"
#endif	/* !MSDOS */

/*
 * ǧڥե
 */

#if	defined(MSDOS) && !defined(USE_LONG_FNAME)
#ifdef	X68K
#ifdef	USE_NEWSAUTH
#define	AUTHORITY_FILE	"_newsauth"
#else	/* !USE_NEWSAUTH */
#define	AUTHORITY_FILE	"_netrc"
#endif	/* !USE_NEWSAUTH */
#else	/* !X68K */
#ifdef	USE_NEWSAUTH
#define	AUTHORITY_FILE	"_newsaut"
#else	/* !USE_NEWSAUTH */
#define	AUTHORITY_FILE	"_netrc"
#endif	/* !USE_NEWSAUTH */
#endif	/* !X68K */
#else	/* !MSDOS || USE_LONG_FNAME */
#ifdef	USE_NEWSAUTH
#define	AUTHORITY_FILE	".newsauth"
#else	/* !USE_NEWSAUTH */
#define	AUTHORITY_FILE	".netrc"
#endif	/* !USE_NEWSAUTH */
#endif	/* !MSDOS || USE_LONG_FNAME */

/*
 * åե̾
 */

#define	MH_READ_FIELD		"Seen:"
#define	MH_REPLY_FIELD		"Replied:"
#define	MH_FORWARD_FIELD	"Forwarded:"

#define	MAX_FIELD_COLUMN	76
#ifdef	X68K
#define	DEFAULT_WIDTH		(96 - 1)
#define	SCAN_SUBJECT_LENGTH	68
#else	/* !X68K */
#define	DEFAULT_WIDTH		(80 - 1)
#define	SCAN_SUBJECT_LENGTH	52
#endif	/* !X68K */
#define	JST_OFFSET		(-9)

/*
 * å³ΰޥ
 */

#define	FOLDER_MASK		0x0001
#define	PATTERN_MASK		0x0002
#define	DATE_MASK		0x0004
#define	FILE_MASK		0x0008
#define	NUMBER_MASK		0x0010
#define	PROCESS_MASK		0x0020
#define	SEQUENCE_MASK		0x0040
#define	NOTIFY_MASK		0x0080
#define	HOST_MASK		0x0100
#define	USER_MASK		0x0200

#if	!(defined(POP3) || defined(MSPL))
struct cpy_hdr {
  char	*field_name;
  char	*field_buff;
  int	buff_size;
};
#endif	/* !(POP3 || MSPL) */

struct option {
  char			*name;
  unsigned short	mode;
};

struct sort_struct {
  int			order;
  unsigned short	year;
  unsigned short	month;
  unsigned short	date;
  unsigned short	hour;
  unsigned short	minute;
  unsigned short	second;
};

extern char	*month_string[];	/* ̾				*/
extern char	*day_string[];		/* ̾			*/

extern char	prog_name[];		/* ץ̾			*/
extern char	home_dir[];		/* ۡǥ쥯ȥ		*/
extern char	tmp_dir[PATH_BUFF];	/* ƥݥǥ쥯ȥ	*/
extern char	mh_path[];		/* ᡼ѥ			*/
extern char	current_folder[];	/* ȥե̾		*/
extern char	target_folder[];	/* åȥե̾		*/
extern char	folder_stack[];		/* եå		*/
extern struct option	option[];	/* ץ			*/
extern int	*message_ptr;		/* ١åݥ	*/
extern int	message_number;		/* ١å		*/
extern int	*target_ptr;		/* åȥåݥ	*/
extern int	target_number;		/* åȥå	*/

extern int	jst_mode;		/* JST ⡼			*/
extern int	x_nsubj_mode;		/* X-Nsubject ⡼		*/
extern int	mime_mode;		/* MIME ⡼			*/
extern int	default_code;		/* ǥեȴ		*/
extern int	scan_width;		/* ǥեȤν		*/

#ifdef	__STDC__
extern void	print_fatal(char *fmt, ...);
					/* 顼ɽ		*/
extern void	print_warning(char *fmt, ...);
					/* ٹɽ		*/
extern int	yes_or_no(char *fmt, ...);
					/* yes/no ǧ		*/
extern int	get_environ(struct cpy_hdr*, int);
					/* Ķ		*/
extern char	*get_opt_param(char**);	/* ץѥ᡼	*/
extern FILE	*open_init_file(void);	/* եOPEN	*/
extern int	check_folder(char*);	/* եå	*/
extern int	create_folder(char*, int);
					/* ե		*/
extern int	check_message(char*, int);
					/* åå	*/
extern int	get_message(char*);	/* å	*/
#ifdef	notdef
extern int	int_compare(int*, int*);/* 		*/
#else	/* !notdef */
extern int	int_compare();		/* 		*/
#endif	/* !notdef */
extern int	get_prev(char*, int);	/* Υå	*/
extern int	get_next(char*, int);	/* Υå	*/
extern int	add_list(char*, int);	/* åꥹɲ	*/
extern int	add_message(int);	/* åɲ	*/
extern int	print_folder(char*, int, int*, int*);
					/* եɽ	*/
extern int	print_folders(char*, int, int*, int*);
					/* եɽ	*/
extern int	get_context(char*, char*);
					/* ƥȼ	*/
extern int	set_context(char*, char*);
					/* ƥ	*/
extern int	get_current(char*);	/* ȼ		*/
extern int	set_current(char*, int);/* 		*/
extern int	get_protect(char*);	/* ץƥȥ⡼ɼ	*/
extern char	*strindex(char*, char*);/* ʸ󸡺		*/
extern void	usage(char*, char*, struct option[], int);
					/* إɽ		*/
extern int	copy_mmh_fields(FILE*, struct cpy_hdr*, int);
					/* եɥԡ	*/
extern int	check_char(unsigned char*);
					/* ʸХȿå	*/
extern char	*get_real_adrs(char*, char*);
					/* ¥ɥ쥹	*/
extern int	scan_message(char*, int, int);
					/* åɽ	*/
extern int	scan_fp(FILE*, int, int);
					/* եɽ	*/
extern void	convert_date(char*, short*, short*, short*, short*, short*,
			     short*, short*, char*);
					/* եեޥåѴ	*/
extern int	gmt_to_jst(short*, short*, short*, short*, short*, short*,
			   short*);	/* GMTJST Ѵ	*/
extern char	*next_param(char*);	/* Υѥ᡼	*/
extern void	recover_jis(char*, char*);
					/* ESC  JIS 	*/
extern void	convert_article_date(char*, short*, short*, short*,
				     short*, short*, short*, short*,
				     char*);
					/* եեޥå	*/
#else	/* !__STDC__ */
extern void	print_fatal();		/* 顼ɽ		*/
extern void	print_warning();	/* ٹɽ		*/
extern int	yes_or_no();		/* yes/no ǧ		*/
extern int	get_environ();		/* Ķ		*/
extern char	*get_opt_param();	/* ץѥ᡼	*/
extern FILE	*open_init_file();	/* եOPEN	*/
extern int	check_folder();		/* եå	*/
extern int	create_folder();	/* ե		*/
extern int	check_message();	/* åå	*/
extern int	get_message();		/* å	*/
extern int	int_compare();		/* 		*/
extern int	get_prev();		/* Υå	*/
extern int	get_next();		/* Υå	*/
extern int	add_list();		/* åꥹɲ	*/
extern int	add_message();		/* åɲ	*/
extern int	print_folder();		/* եɽ	*/
extern int	print_folders();	/* եɽ	*/
extern int	get_context();		/* ƥȼ	*/
extern int	set_context();		/* ƥ	*/
extern int	get_current();		/* ȼ		*/
extern int	set_current();		/* 		*/
extern int	get_protect();		/* ץƥȥ⡼ɼ	*/
extern char	*strindex();		/* ʸ󸡺		*/
extern void	usage();		/* إɽ		*/
extern int	copy_mmh_fields();	/* եɥԡ	*/
extern int	check_char();		/* ʸХȿå	*/

extern char	*get_real_adrs();	/* ¥ɥ쥹	*/
extern int	scan_message();		/* åɽ	*/
extern int	scan_fp();		/* եɽ	*/
extern void	convert_date();		/* եեޥåѴ	*/
extern int	gmt_to_jst();		/* GMTJST Ѵ	*/
extern char	*next_param();		/* Υѥ᡼	*/
extern void	recover_jis();		/* ESC  JIS 	*/
extern void	convert_article_date();	/* եեޥå	*/
#endif	/* !__STDC__ */
