/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Subroutines
 *  File        : mmh_subr.c
 *  Version     : 2.19
 *  First Edit  : 1994-05/14
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"

char	prog_name[PATH_BUFF];		/* ץ̾			*/
char	home_dir[PATH_BUFF];		/* ۡǥ쥯ȥ		*/
char	tmp_dir[PATH_BUFF];		/* ƥݥǥ쥯ȥ	*/
char	current_folder[SMALL_BUFF];	/* ȥե̾		*/
char	target_folder[SMALL_BUFF];	/* åȥե̾		*/
char	folder_stack[BUFF_SIZE];	/* եå		*/
int	*message_ptr = (int*)NULL;	/* ١åݥ	*/
int	message_number = 0;		/* ١å		*/
int	*target_ptr = (int*)NULL;	/* åȥåݥ	*/
int	target_number = 0;		/* åȥå	*/

static int	message_alloc = 0;	/* ١			*/
static int	target_alloc  = 0;	/* åȳ		*/
static int	other_number  = 0;	/* ¾Υե		*/

/*
 * Ķ
 */

#ifdef	__STDC__
int	get_environ(struct cpy_hdr *option_fields, int option_number)
#else	/* !__STDC__ */
int	get_environ(option_fields, option_number)
     struct cpy_hdr	*option_fields;
     int		option_number;
#endif	/* !__STDC__ */
{
  FILE		*fp;
  struct stat	stat_buff;
  char		*env_ptr;
  char		buff[PATH_BUFF];

  env_ptr = (char*)getenv(TMPDIR_ENV);
  if (env_ptr != (char*)NULL) {
    strcpy(tmp_dir, env_ptr);
  } else {
    strcpy(tmp_dir, DEFAULT_TMP);
  }
  env_ptr = (char*)getenv(HOME_ENV);

  if (env_ptr != (char*)NULL) {
    strcpy(home_dir, env_ptr);
#ifdef	X68K
    _addlastsep(home_dir);
#else	/* !X68K */
    strcat(home_dir, "/");
#endif	/* !X68K */
  } else {
    print_fatal("Warning : Can't get home directory.");
    strcpy(home_dir, "./");
  }
  fp = open_init_file();
  if (fp != (FILE*)NULL) {
    copy_mmh_fields(fp, option_fields, option_number);
    fclose(fp);
  }
  if (!mh_path[0]) {
    strcpy(mh_path, MH_DEFAULT_PATH);
  }
  if ((mh_path[0] != '/') && (!(isalpha(mh_path[0]) && (mh_path[1] == ':')))) {
    strcpy(buff, mh_path);
    sprintf(mh_path, "%s%s", home_dir, buff);
  }
  if (!stat(mh_path, &stat_buff)) {
    if (S_ISDIR(stat_buff.st_mode)) {
      if (get_context(current_folder, folder_stack)) {
	strcpy(current_folder, MH_DEFAULT_FOLDER);
      }
      strcpy(target_folder, current_folder);
#ifdef	DEBUG
      printf("MH-PATH:%s\n", mh_path);
      printf("CURRENT:%s,STACK:%s\n", target_folder, folder_stack);
#endif	/* DEBUG */
      return(0);
    }
  }
  print_fatal("Can't open directory \"%s\".", mh_path);
  return(1);
}

/*
 * ץѥ᡼
 */

#ifdef	__STDC__
char	*get_opt_param(char **pptr)
#else	/* !__STDC__ */
char	*get_opt_param(pptr)
     char	**pptr;
#endif	/* !__STDC__ */
{
  char	*ptr1, *ptr2;

  ptr1 = *pptr;
  ptr2 = ptr1;
  while (*ptr2) {
    if ((*ptr2 == ' ') || (*ptr2 == '\t')) {
      *ptr2++ = '\0';
      while ((*ptr2 == ' ') || (*ptr2 == '\t')) {
	ptr2++;
      }
      break;
    }
    ptr2++;
  }
  *pptr = ptr2;
  return(ptr1);
}

/*
 * ե륪ץ
 */

#ifdef	__STDC__
FILE	*open_init_file(void)
#else	/* !__STDC__ */
FILE	*open_init_file()
#endif	/* !__STDC__ */
{
  FILE		*fp;
  char		buff[PATH_BUFF];

  sprintf(buff, "%s%s", home_dir, MH_INIT_FILE);
  fp = fopen(buff, "r");
#ifdef	MH_INIT_FILE2
  if (fp == (FILE*)NULL) {
    sprintf(buff, "%s%s", home_dir, MH_INIT_FILE2);
    fp = fopen(buff, "r");
  }
#endif	/* MH_INIT_FILE2 */
  return(fp);
}

/*
 * եå
 */

#ifdef	__STDC__
int	check_folder(char *folder_name)
#else	/* !__STDC__ */
int	check_folder(folder_name)
     char	*folder_name;
#endif	/* !__STDC__ */
{
  char		buff[PATH_BUFF];
  struct stat	stat_buff;

  sprintf(buff, "%s/%s", mh_path, folder_name);
  if (!stat(buff, &stat_buff)) {
    if (S_ISDIR(stat_buff.st_mode)) {
      return(0);
    }
  }
  return(1);
}

/*
 * ե
 * :ܴؿϺƵ롣
 */

#ifdef	__STDC__
int	create_folder(char *folder_name, int perm)
#else	/* !__STDC__ */
int	create_folder(folder_name, perm)
     char	*folder_name;
     int	perm;
#endif	/* !__STDC__ */
{
  struct stat	stat_buff;
  char		buff1[PATH_BUFF];
  char		buff2[PATH_BUFF];
  char		*ptr;
  int		status;

  sprintf(buff1, "%s/%s", mh_path, folder_name);
  if (stat(buff1, &stat_buff)) {
    status = 0;
    strcpy(buff2, folder_name);
    ptr = separater(buff2);
    if (ptr != (char*)NULL) {
      *ptr = '\0';
      status = create_folder(buff2, perm);
    }
    if (!status) {
      status = mkdir(buff1, perm);
    }
    return(status);
  }
  return(0);
}

/*
 * åå
 */

#ifdef	__STDC__
int	check_message(char *folder_name, int number)
#else	/* !__STDC__ */
int	check_message(folder_name, number)
     char	*folder_name;
     int	number;
#endif	/* !__STDC__ */
{
  char		buff[PATH_BUFF];
  struct stat	stat_buff;

  sprintf(buff, "%s/%s/%d", mh_path, folder_name, number);
  if (!stat(buff, &stat_buff)) {
    if ((stat_buff.st_mode & S_IFMT) == S_IFREG) {
      return(0);
    }
  }
  return(1);
}

/*
 * å
 */

#ifdef	__STDC__
int	get_message(char *folder_name)
#else	/* !__STDC__ */
int	get_message(folder_name)
     char	*folder_name;
#endif	/* !__STDC__ */
{
#ifdef	HAVE_FILES
  FILES_STRUCT	dp;
#else	/* !HAVE_FILES */
  DIR_PTR	*dp;
  DIR		*dir_ptr;
#endif	/* !HAVE_FILES */
  char			buff[PATH_BUFF];
  char			*ptr;
  register int		i;

  if (message_ptr != (int*)NULL) {
    free(message_ptr);
    message_ptr = (int*)NULL;
  }
  message_number = message_alloc = 0;
  if (check_folder(folder_name)) {
    return(1);
  }
  other_number = 0;
#ifdef	HAVE_FILES
  sprintf(buff, "%s/%s/*.*", mh_path, folder_name);
  if (!dos_files(buff, &dp, FILE_ATTR | DIR_ATTR)) {
    do {
#ifdef	__TURBOC__
      ptr = dp.ff_name;
#else	/* !__TURBOC__ */
      ptr = dp.name;
#endif	/* !__TURBOC__ */
      if (*ptr == '.') {
	continue;
      }
#ifdef	__TURBOC__
      if (dp.ff_attrib & DIR_ATTR) {
	other_number++;
	continue;
      }
#else	/* !__TURBOC__ */
      if (dp.atr & DIR_ATTR) {
	other_number++;
	continue;
      }
#endif	/* !__TURBOC__ */
      i = *ptr - '0';
      if ((i >= 0) && (i < 10)) {
	ptr++;
	while (isdigit(*ptr)) {
	  i = i * 10 + *ptr++ - '0';
	}
	if (!*ptr) {
	  if (message_alloc <= message_number) {
	    message_alloc += ALLOC_NUMBER;
	    if (message_ptr != (int*)NULL) {
	      message_ptr = (int*)realloc(message_ptr,
					  message_alloc * sizeof(int));
	    } else {
	      message_ptr = (int*)malloc(message_alloc * sizeof(int));
	    }
	    if (message_ptr == (int*)NULL) {
	      message_number = 0;
	      return(1);
	    }
	  }
	  message_ptr[message_number++] = i;
	}
      } else if ((*ptr != '_') && (*ptr != '#')) {
	other_number++;
      }
    } while (!dos_nfiles(&dp));
  }
#else	/* !HAVE_FILES */
  sprintf(buff, "%s/%s", mh_path, folder_name);
  dir_ptr = opendir(buff);
  if (dir_ptr != (DIR*)NULL) {
    while (1) {
      dp = readdir(dir_ptr);
      if (dp == (DIR_PTR*)NULL) {
	break;
      }
      ptr = dp->d_name;
      if (*ptr == '.') {
	continue;
      }
      i = *ptr - '0';
      if ((i >= 0) && (i < 10)) {
	ptr++;
	while (isdigit(*ptr)) {
	  i = i * 10 + *ptr++ - '0';
	}
	if (!*ptr) {
	  if (message_alloc <= message_number) {
	    message_alloc += ALLOC_NUMBER;
	    if (message_ptr != (int*)NULL) {
	      message_ptr = (int*)realloc(message_ptr,
					  message_alloc * sizeof(int));
	    } else {
	      message_ptr = (int*)malloc(message_alloc * sizeof(int));
	    }
	    if (message_ptr == (int*)NULL) {
	      message_number = 0;
	      return(1);
	    }
	  }
	  message_ptr[message_number++] = i;
	}
      } else if ((*ptr != '.') && (*ptr != '#')) {
	other_number++;
      }
    }
    closedir(dir_ptr);
  }
#endif	/* !HAVE_FILES */
  if (message_number) {
    qsort(message_ptr, message_number, sizeof(int), int_compare);
  }
  return(0);
}

/*
 * 
 */

#ifdef	__STDC__
int	int_compare(int *data1, int *data2)
#else	/* !__STDC__ */
int	int_compare(data1, data2)
     int	*data1;
     int	*data2;
#endif	/* !__STDC__ */
{
  return(*data1 - *data2);
}

/*
 * Υå
 */

#ifdef	__STDC__
int	get_prev(char *folder_name, int current)
#else	/* !__STDC__ */
int	get_prev(folder_name, current)
     char	*folder_name;
     int	current;
#endif	/* !__STDC__ */
{
  register int	i;

  if (get_message(folder_name)) {
    return(1);
  }
  for (i = message_number - 1; i >= 0; i--) {
    if (message_ptr[i] < current) {
      return(message_ptr[i]);
    }
  }
  return(0);
}

/*
 * Υå
 */

#ifdef	__STDC__
int	get_next(char *folder_name, int current)
#else	/* !__STDC__ */
int	get_next(folder_name, current)
     char	*folder_name;
     int	current;
#endif	/* !__STDC__ */
{
  register int	i;

  if (get_message(folder_name)) {
    return(1);
  }
  for (i = 0; i < message_number; i++) {
    if (message_ptr[i] > current) {
      return(message_ptr[i]);
    }
  }
  return(0);
}

/*
 * åꥹɲ
 */

#ifdef	__STDC__
int	add_list(char *ptr, int current)
#else	/* !__STDC__ */
int	add_list(ptr, current)
     char	*ptr;
     int	current;
#endif	/* !__STDC__ */
{
  static char	*param_name[] = {
    MH_ALL_PARAM, MH_CUR_PARAM,
    MH_FIRST_PARAM, MH_LAST_PARAM,
    MH_PREV_PARAM, MH_NEXT_PARAM,
  };
  register int	i, j, k;
  int		prev, next;
  char		*ptr2;
  int		status;

  j = current;
  prev = current = next = -1;
  for (i = 0; i < message_number; i++) {
    if (j <= message_ptr[i]) {
      if (i) {
	prev = i - 1;
      }
      if (j == message_ptr[i]) {
	current = i;
	if (i < (message_number - 1)) {
	  next = i + 1;
	}
      } else {
	next = i;
      }
      break;
    }
  }
  ptr2 = ptr;
  status = 3;
  i = j = k = 0;
  if (isdigit(*ptr)) {
    while (isdigit(*ptr)) {
      i = i * 10 + *ptr++ - '0';
    }
    status = 0;
  } else {
    for (k = 0; k < sizeof(param_name) / sizeof(char*); k++) {
      if (!strncasecmp(ptr, param_name[k], strlen(param_name[k]))) {
	ptr += strlen(param_name[k]);
	switch (k) {
	case 0:		/* all		*/
	  if (!*ptr) {
	    i = j = 1;
	    if (message_number) {
	      j = message_ptr[message_number - 1];
	      status = 0;
	    } else {
	      status = 2;
	    }
	  }
	  break;
	case 1:		/* cur		*/
	  if (current < 0) {
	    status = 4;
	  } else {
	    i = current;
	    status = 0;
	  }
	  break;
	case 2:		/* first	*/
	  if (message_number) {
	    i = 0;
	    status = 0;
	  } else {
	    status = 2;
	  }
	  break;
	case 3:		/* last		*/
	  if (message_number) {
	    i = message_number - 1;
	    status = 0;
	  } else {
	    status = 2;
	  }
	  break;
	case 4:		/* prev		*/
	  if (prev < 0) {
	    status = 5;
	  } else {
	    i = prev;
	    status = 0;
	  }
	  break;
	case 5:		/* next		*/
	  if (next < 0) {
	    status = 6;
	  } else {
	    i = next;
	    status = 0;
	  }
	  break;
	default:
	  status = 99;
	  break;
	}
	break;
      }
    }
  }
  if ((!status) && (!j)) {
    if (*ptr == ':') {
      ptr++;
      j = atoi(ptr);
      if (j) {
	if (!k) {		/* number	*/
	  status = 3;
	} else {
	  if (k == 2) {		/* first	*/
	    if (j < 0) {
	      j = 1;
	    }
	  } else if (k == 3) {	/* last		*/
	    if (j > 0) {
	      j = -j;
	    }
	  }
	  if (j < 0) {
	    current = i;
	    i += (j + 1);
	    j = current;
	    if (i < 0) {
	      i = 0;
	    }
	  } else if (j) {
	    j += (i - 1);
	    if (j >= message_number) {
	      j = message_number - 1;
	    }
	  } else {
	    status = 2;
	  }
	}
      } else {
	status = 3;
      }
    } else if (*ptr == '-') {
      ptr++;
      j = atoi(ptr);
      if (j) {
	if (k) {
	  i = message_ptr[i];
	  k = 0;
	}
      } else {
	status = 3;
	if (k) {
	  i = message_ptr[i];
	}
	for (k = 0; k < sizeof(param_name) / sizeof(char*); k++) {
	  if (!strncasecmp(ptr, param_name[k], strlen(param_name[k]))) {
	    ptr += strlen(param_name[k]);
	    status = 0;
	    switch (k) {
	    case 0:	/* all		*/
	      status = 3;
	      break;
	    case 1:	/* cur		*/
	      if (current < 0) {
		status = 4;
	      } else {
		j = message_ptr[current];
	      }
	      break;
	    case 2:	/* first	*/
	      if (message_number) {
		j = message_ptr[0];
	      } else {
		status = 2;
	      }
	      break;
	    case 3:	/* last		*/
	      if (message_number) {
		j = message_ptr[message_number -1];
	      } else {
		status = 2;
	      }
	      break;
	    case 4:	/* prev		*/
	      if (prev < 0) {
		status = 5;
	      } else {
		j = message_ptr[prev];
	      }
	      break;
	    case 5:	/* next		*/
	      if (next < 0) {
		status = 6;
	      } else {
		j = message_ptr[next];
	      }
	      break;
	    default:
	      status = 99;
	      break;
	    }
	    break;
	  }
	}
	k = 0;
      }
    } else if (!*ptr) {
      j = i;
    } else {
      status = 3;
    }
  }
  if (!status) {
    if (k) {
      i = message_ptr[i];
      j = message_ptr[j];
    }
    status = 2;
    for (k = 0; k < message_number; k++) {
      if ((message_ptr[k] >= i) && (message_ptr[k] <= j)) {
	add_message(message_ptr[k]);
	status = 0;
      }
    }
  }
  switch (status) {
  case 0:
    break;
  case 2:
    print_fatal("No message in range %s.", ptr2);
    break;
  case 1:
    print_fatal("Message %s does not exist.", ptr2);
    break;
  case 3:
    print_fatal("Bad message list %s.", ptr2);
    break;
  case 4:
    print_fatal("No cur message.");
    break;
  case 5:
    print_fatal("No prev message.");
    break;
  case 6:
    print_fatal("No next message.");
    break;
  default:
    print_fatal("Program error.Unknown error in %s.", ptr2);
    break;
  }
  return(status);
}

/*
 * åɲ
 */

#ifdef	__STDC__
int	add_message(int number)
#else	/* !__STDC__ */
int	add_message(number)
     int	number;
#endif	/* !__STDC__ */
{
  int	i;

  for (i = 0; i < target_number; i++) {
    if (target_ptr[i] == number) {
      return(0);
    }
  }
  if (target_alloc <= target_number) {
    target_alloc += ALLOC_NUMBER;
    if (target_ptr != (int*)NULL) {
      target_ptr = (int*)realloc(target_ptr,
				 target_alloc * sizeof(int));
    } else {
      target_ptr = (int*)malloc(target_alloc * sizeof(int));
    }
    if (target_ptr == (int*)NULL) {
      target_number = 0;
      return(1);
    }
  }
  target_ptr[target_number++] = number;
  return(0);
}

/*
 * եɽ(ñ)
 */

#ifdef	__STDC__
int	print_folder(char *folder_name, int flags, int *msg_num_ptr,
		     int *folder_num_ptr)
#else	/* !__STDC__ */
int	print_folder(folder_name, flags, msg_num_ptr, folder_num_ptr)
     char	*folder_name;
     int	flags;
     int	*msg_num_ptr;
     int	*folder_num_ptr;
#endif	/* !__STDC__ */
{
#ifdef	HAVE_FILES
  FILES_STRUCT	dp;
#else	/* !HAVE_FILES */
  DIR_PTR	*dp;
  DIR		*dir_ptr;
#endif	/* !HAVE_FILES */
  char		buff1[PATH_BUFF];
  char		buff2[PATH_BUFF];
  char		*ptr;
  int		max_number;
  int		min_number;
  int		current;

  if (flags & 0x02) {	/* -fast	*/
    printf("%s\n", folder_name);
  } else {
    if (get_message(folder_name)) {
      return(1);
    }
    if (message_number) {
      min_number = message_ptr[0];
      max_number = message_ptr[message_number - 1];
    } else {
      min_number = max_number = 0;
    }
    *folder_num_ptr = *folder_num_ptr + 1;
    *msg_num_ptr = *msg_num_ptr + message_number;
    printf("%22.22s", folder_name);
    if (!strcmp(folder_name, target_folder)) {
      printf("+ has ");
    } else {
      printf("  has ");
    }
    if (message_number) {
      if (message_number == 1) {
	printf("%4d message  (%4d-%4d)", message_number,
	       min_number, max_number);
      } else {
	printf("%4d messages (%4d-%4d)", message_number,
	       min_number, max_number);
      }
      current = get_current(folder_name);
      if (current) {
	printf("; cur=%4d", current);
	if (other_number) {
	  printf("; (others)");
	}
      }
      printf(".\n");
    } else {
      printf("  no messages.\n");
    }
  }
  if (flags & 0x01) {	/* -recurse	*/
#ifdef	HAVE_FILES
    sprintf(buff1, "%s/%s/*.*", mh_path, folder_name);
    if (!dos_files(buff1, &dp, FILE_ATTR | DIR_ATTR)) {
      do {
#ifdef	__TURBOC__
	ptr = dp.ff_name;
#else	/* !__TURBOC__ */
	ptr = dp.name;
#endif	/* !__TURBOC__ */
	if (*ptr != '.') {
	  sprintf(buff2, "%s/%s", folder_name, ptr);
	  print_folder(buff2, flags, msg_num_ptr, folder_num_ptr);
	}
      } while (!dos_nfiles(&dp));
    }
#else	/* !HAVE_FILES */
    sprintf(buff1, "%s/%s", mh_path, folder_name);
    dir_ptr = opendir(buff1);
    if (dir_ptr != (DIR*)NULL) {
      while (1) {
	dp = readdir(dir_ptr);
	if (dp == (DIR_PTR*)NULL) {
	  break;
	}
	ptr = dp->d_name;
	if (*ptr != '.') {
	  sprintf(buff2, "%s/%s", folder_name, ptr);
	  print_folder(buff2, flags, msg_num_ptr, folder_num_ptr);
	}
      }
      closedir(dir_ptr);
    }
#endif	/* !HAVE_FILES */
  }
  return(0);
}

/*
 * եɽ(ʣ)
 */

#ifdef	__STDC__
int	print_folders(char *folder_name, int flags, int *msg_num_ptr,
		      int *folder_num_ptr)
#else	/* !__STDC__ */
int	print_folders(folder_name, flags, msg_num_ptr, folder_num_ptr)
     char	*folder_name;
     int	flags;
     int	*msg_num_ptr;
     int	*folder_num_ptr;
#endif	/* !__STDC__ */
{
#ifdef	HAVE_FILES
  FILES_STRUCT	dp;
#else	/* !HAVE_FILES */
  DIR_PTR	*dp;
  DIR		*dir_ptr;
#endif	/* !HAVE_FILES */
  char			buff1[PATH_BUFF];
  char			buff2[PATH_BUFF];
  char			*ptr;

#ifdef	HAVE_FILES
  if (folder_name) {
    sprintf(buff1, "%s/%s/*.*", mh_path, folder_name);
  } else {
    sprintf(buff1, "%s/*.*", mh_path);
  }
  if (!dos_files(buff1, &dp, FILE_ATTR | DIR_ATTR)) {
    do {
#ifdef	__TURBOC__
      ptr = dp.ff_name;
#else	/* !__TURBOC__ */
      ptr = dp.name;
#endif	/* !__TURBOC__ */
      if (*ptr != '.') {
	if (folder_name) {
	  sprintf(buff2, "%s/%s", folder_name, ptr);
	} else {
	  strcpy(buff2, ptr);
	}
	print_folder(buff2, flags, msg_num_ptr, folder_num_ptr);
      }
    } while (!dos_nfiles(&dp));
    return(0);
  }
#else	/* !HAVE_FILES */
  if (folder_name) {
    sprintf(buff1, "%s/%s", mh_path, folder_name);
  } else {
    strcpy(buff1, mh_path);
  }
  dir_ptr = opendir(buff1);
  if (dir_ptr != (DIR*)NULL) {
    while (1) {
      dp = readdir(dir_ptr);
      if (dp == (DIR_PTR*)NULL) {
	break;
      }
      ptr = dp->d_name;
      if (*ptr != '.') {
	if (folder_name) {
	  sprintf(buff2, "%s/%s", folder_name, ptr);
	} else {
	  strcpy(buff2, ptr);
	}
	print_folder(buff2, flags, msg_num_ptr, folder_num_ptr);
      }
    }
    closedir(dir_ptr);
    return(0);
  }
#endif	/* !HAVE_FILES */
  return(1);
}

/*
 * ȥƥȼ
 */

#ifdef	__STDC__
int	get_context(char *folder_name, char *stack_name)
#else	/* !__STDC__ */
int	get_context(folder_name, stack_name)
     char	*folder_name;
     char	*stack_name;
#endif	/* !__STDC__ */
{
  FILE		*fp;
  char		context_file[PATH_BUFF];
  char		buff[BUFF_SIZE];
  unsigned char	*ptr1, *ptr2;

  *folder_name = '\0';
  *stack_name  = '\0';
  sprintf(context_file, "%s/%s", mh_path, MH_CONTEXT_FILE);
  fp = fopen(context_file, "r");
  if (fp != (FILE*)NULL) {
    while (fgets(buff, sizeof(buff), fp)) {
      ptr1 = ptr2 = (unsigned char*)NULL;
      if (!strncasecmp(buff, MH_CONTEXT_FIELD, sizeof(MH_CONTEXT_FIELD) - 1)) {
	ptr1 = (unsigned char*)&buff[sizeof(MH_CONTEXT_FIELD) - 1];
	ptr2 = (unsigned char*)folder_name;
      } else if (!strncasecmp(buff, MH_STACK_FIELD,
			      sizeof(MH_STACK_FIELD) - 1)) {
	ptr1 = (unsigned char*)&buff[sizeof(MH_STACK_FIELD) - 1];
	ptr2 = (unsigned char*)stack_name;
      }
      if (ptr2 != (unsigned char*)NULL) {
	while ((*ptr1 == ' ') || (*ptr1 == '\t')) {
	  ptr1++;
	}
	while (*ptr1 >= ' ') {
	  *ptr2++ = *ptr1++;
	}
	*ptr2 = '\0';
      }
    }
    fclose(fp);
    if (*folder_name) {
      return(0);
    }
  }
  return(1);
}

/*
 * ȥƥ
 */

#ifdef	__STDC__
int	set_context(char *folder_name, char *stack_name)
#else	/* !__STDC__ */
int	set_context(folder_name, stack_name)
     char	*folder_name;
     char	*stack_name;
#endif	/* !__STDC__ */
{
  FILE		*fp1, *fp2;
  char		context_file[PATH_BUFF];
  char		backup_file[PATH_BUFF];
  char		buff[BUFF_SIZE];

  if (stack_name != (char*)NULL) {
    if (!*stack_name) {
      stack_name = (char*)NULL;
    }
  }
  sprintf(context_file, "%s/%s", mh_path, MH_CONTEXT_FILE);
  sprintf(backup_file, "%s.bak", context_file);
  rename(context_file, backup_file);
  fp1 = fopen(context_file, "w");
  if (fp1 != (FILE*)NULL) {
    fp2 = fopen(backup_file, "r");
    if (fp2 != (FILE*)NULL) {
      while (fgets(buff, sizeof(buff), fp2)) {
	if (!strncasecmp(buff, MH_CONTEXT_FIELD,
			 sizeof(MH_CONTEXT_FIELD) - 1)) {
	  if (folder_name != (char*)NULL) {
	    sprintf(buff, "%s %s\n", MH_CONTEXT_FIELD, folder_name);
	    folder_name = (char*)NULL;
	  } else {
	    continue;
	  }
	} else if (!strncasecmp(buff, MH_STACK_FIELD,
				sizeof(MH_STACK_FIELD) - 1)) {
	  if (stack_name) {
	    sprintf(buff, "%s %s\n", MH_STACK_FIELD, folder_stack);
	    stack_name = (char*)NULL;
	  } else {
	    continue;
	  }
	}
	fputs(buff, fp1);
      }
      fclose(fp2);
    }
    if (folder_name) {
      fprintf(fp1, "%s %s\n", MH_CONTEXT_FIELD, folder_name);
    }
    if (stack_name) {
      fprintf(fp1, "%s %s\n", MH_STACK_FIELD, stack_name);
    }
    fclose(fp1);
    unlink(backup_file);
  } else {
    print_fatal("Can't open context file.");
    rename(backup_file, context_file);
    return(1);
  }
  return(0);
}

/*
 * ȥå
 */

#ifdef	__STDC__
int	get_current(char *folder_name)
#else	/* !__STDC__ */
int	get_current(folder_name)
     char	*folder_name;
#endif	/* !__STDC__ */
{
  FILE			*fp;
  static char		buff[BUFF_SIZE];
  static struct cpy_hdr	count_fields[] = {
    {MH_CURRENT_FIELD,	buff,	sizeof(buff)},
  };

  sprintf(buff, "%s/%s/%s", mh_path, folder_name, MH_SEQ_FILE);
  fp = fopen(buff, "r");
#ifdef	MH_SEQ_FILE2
  if (fp == (FILE*)NULL) {
    sprintf(buff, "%s/%s/%s", mh_path, folder_name, MH_SEQ_FILE2);
    fp = fopen(buff, "r");
  }
#endif	/* MH_SEQ_FILE2 */
  if (fp != (FILE*)NULL) {
    copy_mmh_fields(fp, count_fields,
		    sizeof(count_fields) / sizeof(struct cpy_hdr));
    fclose(fp);
    return(atoi(buff));
  }
  return(0);
}

/*
 * ȥå
 */

#ifdef	__STDC__
int	set_current(char *folder_name, int number)
#else	/* !__STDC__ */
int	set_current(folder_name, number)
     char	*folder_name;
     int	number;
#endif	/* !__STDC__ */
{
  FILE	*fp;
  char	buff[PATH_BUFF];

  sprintf(buff, "%s/%s/%s", mh_path, folder_name, MH_SEQ_FILE);
  fp = fopen(buff, "w");
#ifdef	MH_SEQ_FILE2
  if (fp == (FILE*)NULL) {
    sprintf(buff, "%s/%s/%s", mh_path, folder_name, MH_SEQ_FILE2);
    fp = fopen(buff, "w");
  }
#endif	/* MH_SEQ_FILE2 */
  if (fp != (FILE*)NULL) {
    fprintf(fp, "%s %d\n", MH_CURRENT_FIELD, number);
    fclose(fp);
    return(0);
  }
  return(1);
}

/*
 * ץƥȥ⡼ɼ
 */

#ifdef	__STDC__
int	get_protect(char *ptr)
#else	/* !__STDC__ */
int	get_protect(ptr)
     char	*ptr;
#endif	/* !__STDC__ */
{
  int	perm = 0;

  while ((*ptr == ' ') || (*ptr == '\t')) {
    ptr++;
  }
  if ((*ptr >= '0') && (*ptr <= '7')) {
    while ((*ptr >= '0') && (*ptr <= '7')) {
      perm = perm * 8 + *ptr++ - '0';
    }
    return(perm);
  }
  return(-1);
}

/*
 * ʸ󸡺
 */

#ifdef	__STDC__
char	*strindex(char *str1, char *str2)
#else	/* !__STDC__ */
char	*strindex(str1 ,str2)
     char	*str1;
     char	*str2;
#endif	/* !__STDC__ */
{
  int	length;

  length = strlen(str2);
  while (*str1) {
    if (!strncasecmp(str1, str2, length)) {
      return(str1);
    }
    str1++;
  }
  return((char*)NULL);
}

/*
 * إɽ(ưˡ)
 */

#ifdef	__STDC__
void	usage(char *prog_name, char *syntax, struct option option[],
	      int number)
#else	/* !__STDC__ */
void	usage(prog_name, syntax, option, number)
     char		*prog_name;
     char		*syntax;
     struct option	option[];
     int		number;
#endif	/* !__STDC__ */
{
  int	i;

  fprintf(stderr, "syntax: %s %s\n", prog_name, syntax);
  fprintf(stderr, "  switches are:\n");
  for (i = 0; i < number; i++) {
    if (!option[i].name[0]) {
      continue;
    }
    fprintf(stderr, "  -%s", option[i].name);
    if (option[i].mode & FOLDER_MASK) {
      fprintf(stderr, " folder\n");
    } else if (option[i].mode & PATTERN_MASK) {
      fprintf(stderr, " pattern\n");
    } else if (option[i].mode & DATE_MASK) {
      fprintf(stderr, " date\n");
    } else if (option[i].mode & FILE_MASK) {
      fprintf(stderr, " file\n");
    } else if (option[i].mode & NUMBER_MASK) {
      fprintf(stderr, " number\n");
    } else if (option[i].mode & PROCESS_MASK) {
      fprintf(stderr, " proc\n");
    } else if (option[i].mode & SEQUENCE_MASK) {
      fprintf(stderr, " name\n");
    } else if (option[i].mode & NOTIFY_MASK) {
      fprintf(stderr, " type\n");
    } else if (option[i].mode & HOST_MASK) {
      fprintf(stderr, " host\n");
    } else if (option[i].mode & USER_MASK) {
      fprintf(stderr, " user\n");
    } else {
      fprintf(stderr, "\n");
    }
  }
  fprintf(stderr, "\nversion: MMH %s Copyright (C) By %s %s\n",
	  MMH_VERSION, MMH_AUTHOR, MMH_DATE);
}

/*
 * 顼ɽ
 */

#ifdef	__STDC__
void	print_fatal(char *fmt, ...)
#else	/* !__STDC__ */
void	print_fatal(fmt, va_alist)
     char	*fmt;
#endif	/* !__STDC__ */
{
  va_list	ap;
  char		buff[SMALL_BUFF];

#ifdef	__STDC__
  va_start(ap, fmt);
#else	/* !__STDC__ */
  va_start(ap);
#endif	/* !__STDC__ */
  vsprintf(buff, fmt, ap);
  fprintf(stderr, "%s : ", prog_name);
  fprintf(stderr, "%s\n", buff);
  fflush(stderr);
  va_end(ap);
}

/*
 * ٹɽ
 */

#ifdef	__STDC__
void	print_warning(char *fmt, ...)
#else	/* !__STDC__ */
void	print_warning(fmt, va_alist)
     char	*fmt;
#endif	/* !__STDC__ */
{
  va_list	ap;
  char		buff[SMALL_BUFF];

#ifdef	__STDC__
  va_start(ap, fmt);
#else	/* !__STDC__ */
  va_start(ap);
#endif	/* !__STDC__ */
  vsprintf(buff, fmt, ap);
  fprintf(stderr, "%s : Warning : ", prog_name);
  fprintf(stderr, "%s\n", buff);
  fflush(stderr);
  va_end(ap);
}

#ifdef	__STDC__
int	yes_or_no(char *fmt, ...)
#else	/* !__STDC__ */
int	yes_or_no(fmt, va_alist)
     char	*fmt;
#endif	/* !__STDC__ */
{
  va_list	ap;
  char		buff1[SMALL_BUFF];
  char		buff2[BUFF_SIZE];
  int		status;
  char		*ptr;

#ifdef	__STDC__
  va_start(ap, fmt);
#else	/* !__STDC__ */
  va_start(ap);
#endif	/* !__STDC__ */
  vsprintf(buff1, fmt, ap);
  status = -1;
  while (status < 0) {
    printf("%s", buff1);
    fgets(buff2, sizeof(buff2), stdin);
    ptr = buff2;
    while ((*ptr == ' ') || (*ptr == '\t')) {
      ptr++;
    }
    if ((*ptr == 'Y') || (*ptr == 'y')) {
      status = 1;
    } else if ((*ptr == 'N') || (*ptr == 'n')) {
      status = 0;
    }
  }
  va_end(ap);
  return(status);
}

/*
 * եɥԡ
 */

#ifdef	__STDC__
int	copy_mmh_fields(FILE *fp, struct cpy_hdr *hdr_ptr1, int number)
#else	/* !__STDC__ */
int	copy_mmh_fields(fp, hdr_ptr1, number)
     FILE		*fp;
     struct cpy_hdr	*hdr_ptr1;
     int		number;
#endif	/* !__STDC__ */
{
  struct cpy_hdr	*hdr_ptr2;
  char			buff[BUFF_SIZE];
  char			*ptr1, *ptr2;
  register int		i;

  hdr_ptr2 = hdr_ptr1;
  for (i = 0; i < number; i++) {
    ptr1 = hdr_ptr2->field_buff;
    if (ptr1 != (char*)NULL) {
       *ptr1 = '\0';
    }
    hdr_ptr2++;
  }
  ptr1 = (char*)NULL;
  while (fgets(buff, sizeof(buff), fp)) {
    if ((buff[0] == ' ') || (buff[0] == '\t')) {
      if (ptr1 != (char*)NULL) {
	ptr2 = buff;
	while ((*ptr2 == ' ') || (*ptr2 == '\t')) {
	  ptr2++;
	}
	if ((int)(strlen(ptr1) + strlen(ptr2)) < (hdr_ptr2->buff_size)) {
	  strcat(ptr1, ptr2);
	  ptr2 = ptr1;
	  while (*ptr2) {
	    if ((*ptr2 == '\n') && (!*(ptr2 + 1))) {
	      *ptr2 = '\0';
	      break;
	    }
	    ptr2++;
	  }
	}
      }
    } else {
      ptr1 = (char*)NULL;
      hdr_ptr2 = hdr_ptr1;
      for (i = 0; i < number; i++) {
	if (!strncasecmp(buff, hdr_ptr2->field_name,
			 strlen(hdr_ptr2->field_name))) {
	  ptr1 = hdr_ptr2->field_buff;
	  if (ptr1 != (char*)NULL) {
	    ptr2 = &buff[strlen(hdr_ptr2->field_name)];
	    while ((*ptr2 == ' ') || (*ptr2 == '\t')) {
	      ptr2++;
	    }
	    if ((int)strlen(ptr2) < (hdr_ptr2->buff_size)) {
	      strcpy(ptr1, ptr2);
	    }
	    ptr2 = ptr1;
	    while (*ptr2) {
	      if ((*ptr2 == '\n') && (!*(ptr2 + 1))) {
		*ptr2 = '\0';
		break;
	      }
	      ptr2++;
	    }
	    if (!*ptr1) {		/* եɸ */
	      *ptr1++ = ' ';
	      *ptr1 = '\0';
	    }
	  }
	  break;
	}
	hdr_ptr2++;
      }
      if ((!buff[0]) || (buff[0] == '\n')) {
	break;
      }
    }
  }
  return(0);
}

/*
 * ʸХȿå
 */

#ifdef	__STDC__
int	check_char(unsigned char *ptr)
#else	/* !__STDC__ */
int	check_char(ptr)
     unsigned char	*ptr;
#endif	/* !__STDC__ */
{
#ifdef	MSDOS
  if (((*ptr > 0x80) && (*ptr < 0xa0)) ||
      ((*ptr > 0xdf) && (*ptr < 0xf0))) {	/* SJIS 1Х	*/
    ptr++;
    if (((*ptr > 0x3f) && (*ptr < 0xfd)) &&
	(*ptr != 0x7f)) {			/* SJIS 2Х	*/
      return(2);
    } else if (*ptr) {				/* SJIS 2Х	*/
      return(2);
    }
  }
#else	/* !MSDOS */
  if ((*ptr > 0xa0) && (*ptr < 0xff)) {		/* EUC 1Х	*/
    ptr++;
    if ((*ptr > 0xa0) && (*ptr < 0xff)) {	/* EUC 2Х	*/
      return(2);
    } else if (*ptr) {				/* EUC 2Х	*/
      return(2);
    }
  } else if (*ptr == 0x8e) {			/* EUC (2Х)	*/
    ptr++;
    if ((*ptr > 0xa0) && (*ptr < 0xe0)) {	/* EUC 2Х	*/
      return(2);
    } else if (*ptr) {				/* EUC 2Х	*/
      return(2);
    }
  } else if (*ptr == 0x8f) {			/* EUC (3Х)*/
    ptr++;
    if (*ptr) {
      ptr++;
      if (*ptr) {				/* EUC 3Х	*/
	return(3);
      }
      return(2);
    }
  }
#endif	/* !MSDOS */
  return(1);					/* ¾(ASCII/)	*/
}

/*
 * ʸ(ʸʸ̤ʤ)
 * strncasecmp ʤޥ
 */

#if	defined(LUNA) || defined(SVR3) || defined(SVR4) || defined(SUNOS_40) || defined(SUNOS_3X)
#ifndef	STRNCASECMP
#define	Toupper(c)	((unsigned char) (islower(c) ? toupper(c) : (c)))

int	strncasecmp(s1, s2, n)
	char	*s1;
	char	*s2;
	int	n;
{
  for ( ; (n > 1 &&
	   ((unsigned char)Toupper(*s1) == (unsigned char)Toupper(*s2)));
       s1++ , s2++ , n--) {
    if (*s1 == '\0') {
      return(0);
    }
  }
  return(Toupper(*s1) - Toupper(*s2));
}
#endif	/* !STRNCASECMP */
#endif	/* (LUNA || SVR3 || SVR4 || SUNOS_40 || SUNOS_3X) */
