/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Message check command
 *  File        : msgchk.c
 *  Version     : 2.20
 *  First Edit  : 1995-04/23
 *  Last  Edit  : 1997-12/23
 *  Author      :  
 *
 */

#include	"compat.h"
#if	defined(POP3) || defined(MSPL)
#include	"pop3lib.h"
#include	"termlib.h"
#endif	/* (POP3 || MSPL) */
#include	"mmh.h"

#ifdef	POP3
extern char	auth_file[];		/* 桼ǧڥե	*/
#endif	/* POP3 */

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
char	user_name[SMALL_BUFF] = "";
struct option	option[] = {		/* ץ		*/
  {"help",		0},
  {"date",		0},
  {"nodate",		0},
  {"notify",		NOTIFY_MASK},
  {"nonotify",		NOTIFY_MASK},
#if	defined(POP3) || defined(MSPL)
  {"host",		HOST_MASK},
#else	/* !(POP3 || MSPL) */
  {"",			HOST_MASK},
#endif	/* !(POP3 || MSPL) */
  {"user",		USER_MASK},
};
static struct notify_type {
  char	*type_name;
  int	type_mask;
} notify_type[] = {
  {"all",	0x0F},
  {"mail",	0x01},
  {"nomail",	0x02},
};
static char		msgchk_opt[SMALL_BUFF];
static char		default_folder[SMALL_BUFF];
#if	defined(POP3) || defined(MSPL)
static char		pop3_host[MAXHOSTNAMELEN];
#endif	/* (POP3 || MSPL) */
static struct cpy_hdr	msgchk_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {MH_DEFAULT_FIELD,	default_folder,	sizeof(default_folder)},
  {"msgchkopt:",	msgchk_opt,	sizeof(msgchk_opt)},
};

static int	msgchk_message();		/* å	*/

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
#ifndef	MSDOS
  struct passwd	*passwd;
#endif	/* !MSDOS */
  char		buff[BUFF_SIZE];
  int		status;
  int		i, j, k;
  int		sw;
  int		d_flag = 1;
  int		n_flag = 0x0F;
  char		spool_file[PATH_BUFF];
  char		*user;
  int		u_flag = 0;
  char		*ptr, *ptr2;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }
#if	defined(POP3) || defined(MSPL)
  pop3_connect_mode = 0;
#endif	/* (POP3 || MSPL) */

  /*
   * ե졼
   */

  if (get_environ(msgchk_option,
		  sizeof(msgchk_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }
#ifdef	POP3
  sprintf(auth_file, "%s%s", home_dir, AUTHORITY_FILE);
#endif	/* POP3 */

  user = (char*)NULL;

  /*
   * åβ
   */

  ptr2 = msgchk_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!option[j].name[0]) {
	  continue;
	}
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    usage(prog_name, "[switches] [users]",
		  option, sizeof(option) / sizeof(struct option));
	    exit(0);
	    break;
	  case 1:	/* -date	*/
	    d_flag = 1;
	    break;
	  case 2:	/* -nodate	*/
	    d_flag = 0;
	    break;
	  case 3:	/* -notify	*/
	  case 4:	/* -nonotify	*/
	    sw = j - 3;
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = get_opt_param(&ptr2);
	    }
	    if (ptr != (char*)NULL) {
	      for (k = 0;
		   k < sizeof(notify_type) / sizeof(struct notify_type); k++) {
		if (!strcmp(notify_type[k].type_name, ptr)) {
		  if (sw) {
		    n_flag &= ~notify_type[k].type_mask;
		  } else {
		    n_flag |= notify_type[k].type_mask;
		  }
		  k = -1;
		  break;
		}
	      }
	      if (k >= 0) {
		print_fatal("Illegal argument to -%snotify.", sw ? "no" : "");
		exit(1);
	      }
	    } else {
	      print_fatal("Missing argument to -%snotify.", sw ? "no" : "");
	      exit(1);
	    }
	    break;
	  case 5:	/* -host	*/
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = get_opt_param(&ptr2);
	    }
	    if (ptr != (char*)NULL) {
#if	defined(POP3) || defined(MSPL)
	      strcpy(pop3_host, ptr);
	      pop3_connect_mode = 1;
#else	/* !(POP3 || MSPL) */
	      print_fatal("Program error.");
	      exit(1);
#endif	/* !(POP3 || MSPL) */
	    } else {
	      print_fatal("Host name does not specified.");
	      exit(1);
	    }
	    break;
	  case 6:	/* -user	*/
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = get_opt_param(&ptr2);
	    }
	    if (ptr != (char*)NULL) {
	      user = ptr;
	    } else {
	      print_fatal("User name does not specified.");
	      exit(1);
	    }
	    break;
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    }
  }
  if (user == (char*)NULL) {
    user = (char*)getenv(USER_ENV);
    if (user == (char*)NULL) {
#ifndef	MSDOS
      if (!(passwd = (struct passwd*)getpwuid(geteuid()))) {
	fprintf(stderr, "Can't get password entry.\n");
	exit(1);
      }
      user = passwd->pw_name;
#endif	/* !MSDOS */
      print_fatal("Can't get USER environment.");
      exit(1);
    }
  }
  strcpy(user_name, user);
  sprintf(spool_file, "%s/%s", MH_SPOOL_PATH, user_name);
  status = 0;
  for (i = 1; i < argc; i++) {
    ptr = argv[i];
    if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!option[j].name[0]) {
	  continue;
	}
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  if (option[j].mode) {
	    i++;
	  }
	  break;
	}
      }
    } else if (*ptr) {
      strcpy(user_name, ptr);
      sprintf(spool_file, "%s/%s", MH_SPOOL_PATH, user_name);
      status |= msgchk_message(buff, user_name, spool_file, d_flag, n_flag);
      u_flag = 1;
    }
  }
  if (!u_flag) {
    status = msgchk_message(buff, NULL, spool_file, d_flag, n_flag);
  }
  if ((status >= 0) && buff[0]) {
    printf("%s\n", buff);
  }
  exit(status);
}

#if	defined(POP3) || defined(MSPL)
/*
 * å
 */

static int	msgchk_message(ptr, user, spool_file, d_flag, n_flag)
     char	*ptr;
     char	*user;
     char	*spool_file;
     int	d_flag;
     int	n_flag;
{
  char		*ptr1;
  POP3_ERR_CODE	code;
  int		status;

  *ptr = '\0';
  tcp_init();
  strcpy(mail_spool, spool_file);
  if (pop3_select_server(pop3_host) != POP3_OK) {
    print_fatal("Can't select MSPL/POP3 server.");
    return(-1);
  }
  if (pop3_open() != POP3_OK) {
    print_fatal("Can't connect MSPL/POP3 server.");
    return(-1);
  }
  ptr1 = ptr;
  strcpy(ptr, user ? user : "You");
  while (*ptr) {
    ptr++;
  }
  code = pop3_stat(0);
  if (code == POP3_OK) {
    status = 0;
    if (n_flag & 0x02) {
      sprintf(ptr, " %s new mail waiting",
	      user ? "has" : "have");
    } else {
      *ptr1 = '\0';
    }
  } else if (code == POP3_ERR_NONE) {
    status = 1;
    if (n_flag & 0x01) {
      sprintf(ptr, " %s have any mail waiting",
	      user ? "doesn't" : "don't");
    } else {
      *ptr1 = '\0';
    }
  } else {
    *ptr1 = '\0';
    status = -1;
  }
  pop3_close();
  tcp_exit();
  return(status);
}
#else	/* !(POP3 || MSPL) */
/*
 * å
 */

static int	msgchk_message(ptr, user, spool_file, d_flag, n_flag)
     char	*ptr;
     char	*user;
     char	*spool_file;
     int	d_flag;
     int	n_flag;
{
  char		*ptr1;
  struct tm	*tm;
  time_t	modify_time;
  struct stat	stat_buff;
  int		status;

  status = 1;
  if (!stat(spool_file, &stat_buff)) {
    if (stat_buff.st_size) {
      status = 0;
    }
  } else {
    d_flag = 0;
  }
  ptr1 = ptr;
  strcpy(ptr, user ? user : "You");
  while (*ptr) {
    ptr++;
  }
  if (status) {
    if (n_flag & 0x01) {
      sprintf(ptr, " %s have any mail waiting",
	      user ? "doesn't" : "don't");
    } else {
      *ptr1 = '\0';
    }
  } else if (n_flag & 0x02) {
#ifdef	MSDOS
     sprintf(ptr, " %s new mail waiting", user ? "has" : "have");
#else	/* !MSDOS */
#ifdef	_MINIX
    if (stat_buff.st_mtime > stat_buff.st_atime) {
#else	/* !_MINIX */
#ifdef	STAT_XXX
    if ((stat_buff.st_mtimespec.ts_sec > stat_buff.st_atimespec.ts_sec) ||
	((stat_buff.st_mtimespec.ts_sec == stat_buff.st_atimespec.ts_sec) &&
	 (stat_buff.st_mtimespec.ts_nsec > stat_buff.st_atimespec.ts_nsec))) {
#else	/* !STAT_XXX */
#if	defined(SUNOS_40) || defined(SUNOS_41)
    if ((stat_buff.st_mtime > stat_buff.st_atime) ||
	((stat_buff.st_mtime == stat_buff.st_atime) &&
	 (stat_buff.st_spare1 > stat_buff.st_spare2))) {
#else	/* !(SUNOS_40 || SUNOS_41) */
    if (stat_buff.st_mtime >= stat_buff.st_atime) {
#endif	/* !(SUNOS_40 || SUNOS_41) */
#endif	/* !STAT_XXX */
#endif	/* !_MINIX */
      sprintf(ptr, " %s new mail waiting", user ? "has" : "have");
    } else {
      sprintf(ptr, " %s old mail waiting", user ? "has" : "have");
    }
#endif	/* !MSDOS */
  } else {
    *ptr1 = '\0';
  }
  if (*ptr1 != '\0') {
    while (*ptr) {
      ptr++;
    }
    if (d_flag) {
#ifdef	STAT_XXX
      modify_time = stat_buff.st_mtimespec.ts_sec;
#else	/* !STAT_XXX */
      modify_time = stat_buff.st_mtime;
#endif	/* !STAT_XXX */
      tm = localtime(&modify_time);
      if (tm != (struct tm*)NULL) {
#ifdef	MSDOS
	sprintf(ptr, "; last read on %s, %2d %s 19%d %02d:%02d:%02d %s",
		day_string[tm->tm_wday + 1], tm->tm_mday,
		month_string[tm->tm_mon + 1], tm->tm_year,
		tm->tm_hour, tm->tm_min, tm->tm_sec, "JST");
#else	/* !MSDOS */
#ifdef	_MINIX
	sprintf(ptr, "; last read on %s, %2d %s 19%d %02d:%02d:%02d %s",
		day_string[tm->tm_wday + 1], tm->tm_mday,
		month_string[tm->tm_mon + 1], tm->tm_year,
		tm->tm_hour, tm->tm_min, tm->tm_sec,
		((tm->tm_isdst == 1) ? tzname[1] : tzname[0]));
#else	/* !_MINIX */
	sprintf(ptr, "; last read on %s, %2d %s 19%d %02d:%02d:%02d %s",
		day_string[tm->tm_wday + 1], tm->tm_mday,
		month_string[tm->tm_mon + 1], tm->tm_year,
		tm->tm_hour, tm->tm_min, tm->tm_sec, tm->tm_zone);
#endif	/* !_MINIX */
#endif	/* !MSDOS */
      } else {
	sprintf(ptr, "; last read on unknown");
      }
    }
  }
  return(status);
}
#endif	/* !(POP3 || MSPL) */
