/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Pick message command
 *  File        : pick.c
 *  Version     : 2.19
 *  First Edit  : 1994-06/20
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"
#include	"kanjilib.h"
#include	"mimelib.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
struct option	option[] = {		/* ץ		*/
  {"help",		0},
#ifdef	MIME
  {"mime",		0},
  {"nomime",		0},
#endif	/* MIME */
  {"from",		PATTERN_MASK},
  {"to",		PATTERN_MASK},
  {"cc",		PATTERN_MASK},
  {"subject",		PATTERN_MASK},
  {"datefield",		PATTERN_MASK},
  {"date",		DATE_MASK},
  {"before",		DATE_MASK},
  {"after",		DATE_MASK},
  {"-othercomponent",	PATTERN_MASK},
#ifdef	notdef
  {"and",		0},
  {"or",		0},
  {"not",		0},
#endif	/* notdef */
};
static char		pick_opt[SMALL_BUFF];
static struct cpy_hdr	pick_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {"pickopt",		pick_opt,	sizeof(pick_opt)},
};
static char	*special_date[] = {
  "yesterday",
  "today",
  "tomorrow",
  "sunday",
  "monday",
  "tuesday",
  "wednesday",
  "thursday",
  "friday",
  "saturday",
};

static int	pick_message();		/* å	*/
static void	get_date_param();	/* ѥ᡼	*/

typedef enum {
  HEAD_COMPARE,
  ADRS_COMPARE,
  SUBJECT_COMPARE,
  INDEX_COMPARE,
  DATE_COMPARE,
  BEFORE_COMPARE,
  AFTER_COMPARE
} check_type;

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  static char	othercomponent[SMALL_BUFF];
  int		status;
  int		current;
  int		i, j, k;
  int		t_flag = 0;
  int		c_flag = HEAD_COMPARE;
  char		*field = (char*)NULL;
  char		*pattern = (char*)NULL;
  char		*ptr, *ptr2;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }

  /*
   * ե졼
   */

  if (get_environ(pick_option, sizeof(pick_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }

  /*
   * åβ
   */

  ptr2 = pick_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if (*ptr == '+') {
      ptr++;
      if (*ptr) {
	strcpy(target_folder, ptr);
	t_flag = 1;
      } else {
	print_fatal("Folder does not specified.");
	exit(1);
      }
    } else if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      if (*ptr == '-') {
        ptr++;
        if (!*ptr) {
	  print_fatal("Field does not specified.");
	  exit(1);
        }
        if (field != (char*)NULL) {
	  print_fatal("Too many field specified.");
	  exit(1);
        }
	sprintf(othercomponent, "%s:", ptr);
	field = othercomponent;
	c_flag = HEAD_COMPARE;
	pattern = (char*)NULL;
	if (i > 0) {
	  if (++i < argc) {
	    pattern = argv[i];
	  }
	} else if (*ptr2) {
	  pattern = get_opt_param(&ptr2);
	}
	if (pattern == (char*)NULL) {
	  print_fatal("Pattern does not specified.");
	}
        j = -1;
      } else {
        for (j = 0; j < (sizeof(option) / sizeof(struct option) - 1); j++) {
	  if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	    switch (j) {
	    case 0:	/* -help	*/
	      usage(prog_name, "[+folder] [msg] [switches]",
		    option, sizeof(option) / sizeof(struct option));
	      exit(0);
	      break;
#ifdef	MIME
	    case 1:	/* -mime	*/
	      mime_mode = 1;
	      break;
	    case 2:	/* -nomime	*/
	      mime_mode = 0;
	      break;
#endif	/* MIME */
	    default:
	      if (field != (char*)NULL) {
		print_fatal("Too many field specified.");
		exit(1);
	      }
#ifdef	MIME
	      k = j - 3;
#else	/* !MIME */
	      k = j - 1;
#endif	/* !MIME */
	      switch (k) {
	      case 0:
		field = FROM_FIELD;
		c_flag = ADRS_COMPARE;
	        break;
	      case 1:
		field = TO_FIELD;
		c_flag = ADRS_COMPARE;
	        break;
	      case 2:
		field = CC_FIELD;
		c_flag = ADRS_COMPARE;
	        break;
	      case 3:
		field = SUBJECT_FIELD;
		c_flag = SUBJECT_COMPARE;
	        break;
	      case 4:
		field = DATE_FIELD;
		c_flag = INDEX_COMPARE;
	        break;
	      case 5:
		field = DATE_FIELD;
		c_flag = DATE_COMPARE;
	        break;
	      case 6:
		field = DATE_FIELD;
		c_flag = BEFORE_COMPARE;
	        break;
	      case 7:
		field = DATE_FIELD;
		c_flag = AFTER_COMPARE;
	        break;
	      }
	      if (++i < argc) {
		pattern = argv[i];
	      } else {
		if (k < 4) {
		  print_fatal("Pattern does not specified.");
		} else {
		  print_fatal("Date does not specified.");
		}
		exit(1);
	      }
	      break;
	    }
	    j = -1;
	    break;
	  }
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    }
  }
  get_message(target_folder);
  current = get_current(target_folder);
  for (i = 1; i < argc; i++) {
    ptr = argv[i];
    if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      if (*ptr == '-') {
        i++;
      } else {
	for (j = 0; j < (sizeof(option) / sizeof(struct option) - 1); j++) {
	  if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	    if (option[j].mode) {
	      i++;
	    }
	    break;
	  }
	}
      }
    } else if (*ptr != '+') {
      if (add_list(ptr, current)) {
	exit(1);
      }
    }
  }
  if (check_folder(target_folder)) {
    print_fatal("Folder %s does not exist.", target_folder);
    exit(1);
  }
  status = 1;
  if (!target_number) {
    target_number = message_number;
    target_ptr = message_ptr;
  }
  if (!target_number) {
    print_fatal("No messages in %s.", target_folder);
    exit(1);
  }
  qsort(target_ptr, target_number, sizeof(int), int_compare);
  for (i = 0; i < target_number; i++) {
    if (!pick_message(target_folder, target_ptr[i], field, pattern,
		      c_flag)) {
      status = 0;
      printf("%d\n", target_ptr[i]);
    }
  }
  if (status) {
    print_fatal("No messages match specification.");
  } else {
    if (t_flag) {
      set_context(target_folder, folder_stack);
    }
  }
  exit(status);
}

/*
 * å
 */

static int	pick_message(folder_name, number, field, pattern, c_flag)
     char	*folder_name;
     int	number;
     char	*field;
     char	*pattern;
     int	c_flag;
{
  FILE			*fp;
  static char		buff1[BUFF_SIZE];
  static char		buff2[BUFF_SIZE];
  static struct cpy_hdr	pick_fields[] = {
    {(char*)NULL,	buff1,	sizeof(buff1)},
    {X_NSUBJ_FIELD,	buff2,	sizeof(buff2)},
  };
  char			zone_buff[SMALL_BUFF];
  short			year1, month1, date1, day1, hour1, minute1, second1;
  short			year2, month2, date2, day2, hour2, minute2, second2;

  sprintf(buff1, "%s/%s/%d", mh_path, folder_name, number);
  fp = fopen(buff1, "r");
  if (fp == (FILE*)NULL) {
    return(1);
  }
  if (field != (char*)NULL) {
    pick_fields[0].field_name = field;
    copy_mmh_fields(fp, pick_fields,
		    sizeof(pick_fields) / sizeof(struct cpy_hdr));
    if (buff2[0] && x_nsubj_mode && (c_flag == SUBJECT_COMPARE)) {
      recover_jis(buff1, buff2);
#ifdef	MSDOS
      to_sjis(buff2, buff1, default_code);
#else	/* !MSDOS */
      to_euc(buff2, buff1, default_code);
#endif	/* !MSDOS */
      strcpy(buff1, buff2);
    }
  }
  fclose(fp);
  if (field == (char*)NULL) {
    return(0);
  }
#ifdef	MIME
  if (mime_mode) {
    mime_decode(buff1, buff2);
#ifdef	MSDOS
    to_sjis(buff1, buff2, default_code);
#else	/* !MSDOS */
    to_euc(buff1, buff2, default_code);
#endif	/* !MSDOS */
  } else {
#ifdef	MSDOS
    to_sjis(buff2, buff1, default_code);
#else	/* !MSDOS */
    to_euc(buff2, buff1, default_code);
#endif	/* !MSDOS */
    strcpy(buff1, buff2);
  }
#else	/* !MIME */
#ifdef	MSDOS
  to_sjis(buff2, buff1, default_code);
#else	/* !MSDOS */
  to_euc(buff2, buff1, default_code);
#endif	/* !MSDOS */
  strcpy(buff1, buff2);
#endif	/* !MIME */
  switch (c_flag) {
  case HEAD_COMPARE:
    return(strncmp(buff1, pattern, strlen(pattern)));
    break;
  case SUBJECT_COMPARE:
  case INDEX_COMPARE:
  default:
    return(!strindex(buff1, pattern));
    break;
  case ADRS_COMPARE:
    get_real_adrs(buff1, buff2);
    return(strncasecmp(buff2, pattern, strlen(pattern)));
    break;
  case DATE_COMPARE:
    convert_date(buff1, &year1, &month1, &date1, &day1, &hour1,
		 &minute1, &second1, buff2);
    get_date_param(pattern, &year2, &month2, &date2, &day2, &hour2,
		   &minute2, &second2, zone_buff);
    if (year2) {
      if (year1 != year2) {
        return(1);
      }
    }
    if (month1 != month2) {
      return(1);
    }
    if (date1 != date2) {
      return(1);
    }
    return(0);
    break;
  case BEFORE_COMPARE:
    convert_date(buff1, &year1, &month1, &date1, &day1, &hour1,
		 &minute1, &second1, buff2);
    get_date_param(pattern, &year2, &month2, &date2, &day2, &hour2,
		   &minute2, &second2, zone_buff);
    if (year2) {
      if (year1 > year2) {
        return(1);
      } else if (year1 < year2) {
        return(0);
      }
    }
    if (month1 > month2) {
      return(1);
    } else if (month1 < month2) {
      return(0);
    }
    if (date1 >= date2) {
      return(1);
    }
    return(0);
    break;
  case AFTER_COMPARE:
    convert_date(buff1, &year1, &month1, &date1, &day1, &hour1,
		 &minute1, &second1, buff2);
    get_date_param(pattern, &year2, &month2, &date2, &day2, &hour2,
		   &minute2, &second2, zone_buff);
    if (year2) {
      if (year1 < year2) {
        return(1);
      } else if (year1 > year2) {
        return(0);
      }
    }
    if (month1 < month2) {
      return(1);
    } else if (month1 > month2) {
      return(0);
    }
    if (date1 <= date2) {
      return(1);
    }
    return(0);
    break;
  }
  return(0);
}

/*
 * ѥ᡼
 */

static void	get_date_param(dates, year, month, date, day,
			       hour, minute, second, zone_name)
     char	*dates;
     short	*year;
     short	*month;
     short	*date;
     short	*day;
     short	*hour;
     short	*minute;
     short	*second;
     char	*zone_name;
{
  time_t		now_time;
  struct tm		*tm;
  register short	i, j;
  int			offset;
  int			jst_flag;

  while ((*dates == ' ') || (*dates == '\t')) {
    dates++;
  }
  now_time = time((time_t*)NULL);
  tm = localtime(&now_time);
  *year   = tm->tm_year + 1900;
  *month  = tm->tm_mon + 1;
  *date   = tm->tm_mday;
  *day    = tm->tm_wday + 1;
  *hour   = tm->tm_hour;
  *minute = tm->tm_min;
  *second = tm->tm_sec;

  for (i = 0; i < (sizeof(special_date) / sizeof(char*)); i++) {
    if (!strncasecmp(special_date[i], dates, strlen(special_date[i]))) {
      switch (i) {
      case 0:
	now_time -= (time_t)86400;
	break;
      case 1:
	break;
      case 2:
	now_time += (time_t)86400;
	break;
      default:
	j = tm->tm_wday - (i - 3);
	if (j <= 0) {
	  j += 7;
	}
	while (j-- > 0) {
	  now_time -= (time_t)86400;
	}
	break;
      }
      tm = localtime(&now_time);
      *year   = tm->tm_year + 1900;
      *month  = tm->tm_mon + 1;
      *date   = tm->tm_mday;
      *day    = tm->tm_wday + 1;
      *hour   = tm->tm_hour;
      *minute = tm->tm_min;
      *second = tm->tm_sec;
      return;
    }
  }
  if (!*dates) {
    return;
  }
  for (i = 0; i < 8; i++) {
    if (!strncasecmp(dates, day_string[i], 3)) {
      *day = i;
      i = -1;
      break;
    }
  }
  if (i < 0) {
    dates = next_param(dates);
  }
  for (i = 0; i < 13; i++) {
    if (!strncasecmp(dates, month_string[i], 3)) {
      *month = i;		/* 	*/
      i = -1;
      break;
    }
  }
  if (i < 0) {			/* (Date,) Month Day Time Year Zone */	
    dates = next_param(dates);
    if (!isdigit(*dates)) {
      return;
    }
    *date = atoi(dates);	/* 	*/
    while (*dates) {
      if (*dates++ == ' ') {
	break;
      }
    }
    if (!isdigit(*dates)) {
      return;
    }
    *hour = atoi(dates);	/* 	*/
    while (*dates) {
      if (*dates++ == ':') {
	break;
      }
    }
    if (!isdigit(*dates)) {
      return;
    }
    *minute = atoi(dates);	/* ʬ	*/
    while (isdigit(*dates)) {
      dates++;
    }
    if (*dates == ':') {
      dates++;
      if (!isdigit(*dates)) {
	return;
      }
      *second = atoi(dates);	/* 	*/
    }
    dates = next_param(dates);
    if (!isdigit(*dates)) {
      return;
    }
    *year = atoi(dates);	/* ǯ	*/
    if ((*year > 0) && (*year < 1000)) {
      *year += 1900;
    }
    dates = next_param(dates);
  } else {			/* (Date,) Day Month Year Time Zone */
    *date = atoi(dates);	/* 	*/
    dates = next_param(dates);
    for (i = 0; i < 13; i++) {
      if (!strncasecmp(dates, month_string[i], 3)) {
	*month = i;		/* 	*/
	break;
      }
    }
    dates = next_param(dates);
    if (!isdigit(*dates)) {
      return;
    }
    *year = atoi(dates);	/* ǯ	*/
    if ((*year > 0) && (*year < 100)) {
      *year += 1900;
    }
    dates = next_param(dates);
    if (!isdigit(*dates)) {
      return;
    }
    if (!isdigit(*dates)) {
      return;
    }
    *hour = atoi(dates);	/* 	*/
    while (*dates) {
      if (*dates++ == ':') {
	break;
      }
    }
    if (!isdigit(*dates)) {
      return;
    }
    *minute = atoi(dates);	/* ʬ	*/
    while (isdigit(*dates)) {
      dates++;
    }
    if (*dates == ':') {
      dates++;
      if (!isdigit(*dates)) {
	return;
      }
      *second = atoi(dates);	/* 	*/
    }
    dates = next_param(dates);
  }
  strcpy(zone_name, dates);
  jst_flag = 0;
  if (!strncmp(dates, "GMT", 3)) {
    dates += 3;
  }
  if (*dates == '+') {
    dates++;
    offset = atoi(dates);
    if (jst_mode) {
      *hour   -= offset / 100;
      *minute -= offset % 100;
    }
    jst_flag = 1;
  } else if (*dates == '-') {
    dates++;
    offset = atoi(dates);
    if (jst_mode) {
      *hour   += offset / 100;
      *minute += offset % 100;
    }
    jst_flag = 1;
  } else if (*dates < ' ') {
    jst_flag = 1;
  }
  if (jst_flag) {
    strcpy(zone_name, "JST");
    gmt_to_jst(year, month, date, day, hour, minute, second);
  }
  dates = zone_name;
  while (*dates) {
    if (*dates == '\n') {
      *dates = '\0';
    }
    dates++;
  }
}
