/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Refile command
 *  File        : refile.c
 *  Version     : 2.19
 *  First Edit  : 1994-05/22
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
struct option	option[] = {		/* ץ		*/
  {"help",		0},
  {"src",		FOLDER_MASK},
  {"interactive",	0},
  {"nointeractive",	0},
};
static char		folder_perm[SMALL_BUFF];
static char		refile_opt[SMALL_BUFF];
static struct cpy_hdr	refile_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {MH_F_PERM_FIELD,	folder_perm,	sizeof(folder_perm)},
  {"refileopt:",	refile_opt,	sizeof(refile_opt)},
};

static int	refile_message();	/* åư	*/

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  int		status;
  int		current;
  int		i, j;
  int		i_flag = 0;
  int		t_flag = 0;
  int		perm;
  char		*ptr, *ptr2;
  char		source_folder[SMALL_BUFF];
  char		buff[PATH_BUFF];
  int		target;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }

  /*
   * ե졼
   */

  if (get_environ(refile_option, sizeof(refile_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }
  strcpy(source_folder, target_folder);

  /*
   * åβ
   */

  ptr2 = refile_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if (*ptr == '+') {
      ptr++;
      if (*ptr) {
	strcpy(target_folder, ptr);
	t_flag = 1;
      } else {
	print_fatal("Folder does not specified.");
	exit(1);
      }
    } else if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    usage(prog_name, "[+folder] [msg] [switches]",
		  option, sizeof(option) / sizeof(struct option));
	    exit(0);
	    break;
	  case 1:	/* -src		*/
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = get_opt_param(&ptr2);
	    }
	    if (ptr != (char*)NULL) {
	      strcpy(source_folder, ptr);
	    } else {
	      print_fatal("Source folder does not specified.");
	      exit(1);
	    }
	    break;
	  case 2:	/* -interactive	*/
	    i_flag = 1;
	    break;
	  case 3:	/* -nointeractive */
	    i_flag = 0;
	    break;
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    }
  }
  get_message(source_folder);
  current = get_current(source_folder);
  for (i = 1; i < argc; i++) {
    ptr = argv[i];
    if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  if (option[j].mode) {
	    i++;
	  }
	  break;
	}
      }
    } else if (*ptr != '+') {
      if (add_list(ptr, current)) {
	exit(1);
      }
    }
  }
  if (check_folder(source_folder)) {
    print_fatal("Folder %s does not exist.", source_folder);
    exit(1);
  }
  if (check_folder(target_folder)) {
    if (yes_or_no("Create folder \"%s\"? ", target_folder)) {
      sprintf(buff, "%s/%s", mh_path, target_folder);
      perm = get_protect(folder_perm);
      if (perm < 0) {
	perm = S_IEXEC | S_IREAD | S_IWRITE;
      }
      if (create_folder(target_folder, perm)) {
        print_fatal("Can't create folder %s.", target_folder);
        exit(1);
      }
    } else {
      exit(1);
    }
  }
  status = 0;
  if (!target_number) {
    if (current <= 0) {
      print_fatal("Can't get current message.");
      exit(1);
    }
    if (add_list(MH_CUR_PARAM, current)) {
      exit(1);
    }
  }
  if (!target_number) {
    print_fatal("Unexpected system error.");
    exit(1);
  }
  qsort(target_ptr, target_number, sizeof(int), int_compare);
  get_message(target_folder);
  if (message_number) {
    target = message_ptr[message_number - 1] + 1;
  } else {
    target = 1;
  }
  for (i = 0; i < target_number; i++) {
    if (i_flag && (!yes_or_no("Refile message %d? ", target_ptr[i]))) {
      continue;
    }
#ifdef	DEBUG
    printf("%s:%d->%s:%d\n", source_folder, target_ptr[i], target_folder, target);
#endif	/* DEBUG */
    if (refile_message(source_folder, target_folder, target_ptr[i], target)) {
      status = 1;
    } else {
      target++;
    }
  }
#ifdef	notdef
  if (t_flag) {
    set_context(target_folder, folder_stack);
  }
#endif	/* notdef */
  exit(status);
}

/*
 * åư
 */

static int	refile_message(folder_name1, folder_name2, number1, number2)
     char	*folder_name1;
     char	*folder_name2;
     int	number1;
     int	number2;
{
  char	buff1[PATH_BUFF];
  char	buff2[PATH_BUFF];
  int	status;

  sprintf(buff1, "%s/%s/%d", mh_path, folder_name1, number1);
  sprintf(buff2, "%s/%s/%d", mh_path, folder_name2, number2);
  status = rename(buff1, buff2);
  if (status) {
    print_fatal("Can't refile message %d.", number1);
  }
  return(status);
}
