/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Remove message command
 *  File        : rmm.c
 *  Version     : 2.19
 *  First Edit  : 1994-05/22
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
struct option	option[] = {		/* ץ		*/
  {"help",		0},
  {"remove",		0},
  {"noremove",		0},
  {"interactive",	0},
  {"nointeractive",	0},
};
static char		rmm_proc[PATH_BUFF];
static char		rmm_opt[SMALL_BUFF];
static struct cpy_hdr	rmm_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {"rmmproc:",		rmm_proc,	sizeof(rmm_proc)},
  {"rmmopt:",		rmm_opt,	sizeof(rmm_opt)},
};

static int	remove_message();	/* å	*/

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  int		status;
  int		current;
  int		i, j;
  int		i_flag = 0;
  int		r_flag = 0;
  int		t_flag = 0;
  char		*ptr, *ptr2;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }

  /*
   * ե졼
   */

  if (get_environ(rmm_option, sizeof(rmm_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }
#ifdef	DEBUG
  printf("rmmproc=%s\n", rmm_proc);
#endif	/* DEBUG */

  /*
   * åβ
   */

  ptr2 = rmm_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if (*ptr == '+') {
      ptr++;
      if (*ptr) {
	strcpy(target_folder, ptr);
	t_flag = 1;
      } else {
	print_fatal("Folder does not specified.");
	exit(1);
      }
    } else if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    usage(prog_name, "[+folder] [msg] [switches]",
		  option, sizeof(option) / sizeof(struct option));
	    exit(0);
	    break;
	  case 1:	/* -remove	*/
	    r_flag = 1;
	    break;
	  case 2:	/* -noremove	*/
	    r_flag = 0;
	    break;
	  case 3:	/* -interactive	*/
	    i_flag = 1;
	    break;
	  case 4:	/* -nointeractive */
	    i_flag = 0;
	    break;
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    }
  }
  get_message(target_folder);
  current = get_current(target_folder);
  for (i = 1; i < argc; i++) {
    ptr = argv[i];
    if ((*ptr != '+') && (*ptr != '-') && (*ptr != '/')) {
      if (add_list(ptr, current)) {
	exit(1);
      }
    }
  }
  if (check_folder(target_folder)) {
    print_fatal("Folder %s does not exist.", target_folder);
    exit(1);
  }
  status = 0;
  if (!target_number) {
    if (current <= 0) {
      print_fatal("Can't get current message.");
      exit(1);
    }
    if (add_list(MH_CUR_PARAM, current)) {
      exit(1);
    }
  }
  if (!target_number) {
    print_fatal("Unexpected system error.");
    exit(1);
  }
  qsort(target_ptr, target_number, sizeof(int), int_compare);
  for (i = 0; i < target_number; i++) {
    if (i_flag && (!yes_or_no("Remove message %d? ", target_ptr[i]))) {
      continue;
    }
    if (remove_message(target_folder, target_ptr[i], r_flag)) {
      status = 1;
    }
  }
  if (t_flag) {
    set_context(target_folder, folder_stack);
  }
  exit(status);
}

/*
 * å
 */

static int	remove_message(folder_name, number, r_flag)
     char	*folder_name;
     int	number;
     int	r_flag;
{
  char	buff1[PATH_BUFF];
  char	buff2[BUFF_SIZE];
  char	*ptr;
#ifdef	MSDOS
  char	*argv[8];
  int	i;
#endif	/* MSDOS */
  int	status;

  sprintf(buff1, "%s/%s/%d", mh_path, folder_name, number);
  if (r_flag) {
    return(unlink(buff1));
  }
  if (rmm_proc[0]) {
    ptr = buff2;
#ifndef	MSDOS
    strcpy(ptr, "exec ");
    while (*ptr) {
      ptr++;
    }
#endif	/* !MSDOS */
    sprintf(ptr, "%s %s", rmm_proc, buff1);
#ifdef	MSDOS
    i = 0;
    while (*ptr) {
      argv[i++] = ptr;
      while (*ptr) {
	if ((*ptr == ' ') || (*ptr == '\t')) {
	  *ptr++ = '\0';
	  break;
	}
	ptr++;
      }
      if (i >= ((sizeof(argv) / sizeof(char*)) - 1)) {
	break;
      }
      while ((*ptr == ' ') || (*ptr == '\t')) {
	ptr++;
      }
    }
    argv[i] = (char*)NULL;
    status = spawnlp(P_WAIT, argv[0], argv[0], argv[1], argv[2], argv[3],
		     argv[4], argv[5], argv[6], argv[7]);
#else	/* !MSDOS */
    status = system(buff2);
#endif	/* !MSDOS */
  } else {
    sprintf(buff2, "%s/%s/#%d", mh_path, folder_name, number);
#ifdef	MSDOS
    unlink(buff2);
#endif	/* MSDOS */
    status = rename(buff1, buff2);
  }
  if (status) {
    print_fatal("Can't remove message %d.", number);
  }
  return(status);
}
