/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Sort message command
 *  File        : sortm.c
 *  Version     : 2.19
 *  First Edit  : 1994-06/23
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
struct option	option[] = {		/* ץ		*/
  {"help",		0},
  {"verbose",		0},
  {"noverbose",		0},
  {"-othercomponent",	0},
};
static char		sortm_opt[SMALL_BUFF];
static struct cpy_hdr	sortm_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {"sortmopt:",		sortm_opt,	sizeof(sortm_opt)},
};

static int	sort_message();		/* å	*/
static int	sort_compare();		/* ե	*/

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  static char	othercomponent[SMALL_BUFF];
  int		status;
  int		current;
  int		i, j;
  int		t_flag = 0;
  int		v_flag = 0;
  char		*field = (char*)NULL;
  char		*ptr, *ptr2;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }

  /*
   * ե졼
   */

  if (get_environ(sortm_option, sizeof(sortm_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }

  /*
   * åβ
   */

  ptr2 = sortm_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if (*ptr == '+') {
      ptr++;
      if (*ptr) {
	strcpy(target_folder, ptr);
	t_flag = 1;
      } else {
	print_fatal("Folder does not specified.");
	exit(1);
      }
    } else if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      if (*ptr == '-') {
        ptr++;
        if (!*ptr) {
	  print_fatal("Field does not specified.");
	  exit(1);
        }
        if (field) {
	  print_fatal("Too many field specified.");
	  exit(1);
        }
	sprintf(othercomponent, "%s:", ptr);
	field = othercomponent;
      } else {
	for (j = 0; j < (sizeof(option) / sizeof(struct option) - 1); j++) {
	  if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	    switch (j) {
	    case 0:	/* -help	*/
	      usage(prog_name, "[+folder] [msg] [switches]",
		    option, sizeof(option) / sizeof(struct option));
	      exit(0);
	      break;
	    case 1:	/* -verbose	*/
	      v_flag = 1;
	      break;
	    case 2:	/* -noverbose	*/
	      v_flag = 0;
	      break;
	    default:
	      break;
	    }
	    j = -1;
	    break;
	  }
	}
	if (j >= 0) {
	  print_fatal("Bad option.");
	  exit(1);
	}
      }
    }
  }
  get_message(target_folder);
  current = get_current(target_folder);
  for (i = 1; i < argc; i++) {
    ptr = argv[i];
    if ((*ptr != '+') && (*ptr != '-') && (*ptr != '/')) {
      if (add_list(ptr, current)) {
	exit(1);
      }
    }
  }
  if (check_folder(target_folder)) {
    print_fatal("Folder %s does not exist.", target_folder);
    exit(1);
  }
  status = 0;
  if (!target_number) {
    target_number = message_number;
    target_ptr = message_ptr;
  }
  if (!target_number) {
    print_fatal("No messages in %s.", target_folder);
    exit(1);
  }
  qsort(target_ptr, target_number, sizeof(int), int_compare);
  if (v_flag) {
    if (field) {
      printf("Sorting by %s field.\n", field);
    } else {
      printf("Sorting by date field.\n");
    }
  }
  status = sort_message(target_folder, field, v_flag);
  if (status) {
    print_fatal("Sort message failed.", target_folder);
    exit(1);
  }
#ifdef	notdef
  if (t_flag) {
    set_context(target_folder, folder_stack);
  }
#endif	/* notdef */
  exit(status);
}

/*
 * å
 */

static int	sort_message(folder_name, field, v_flag)
     char	*folder_name;
     char	*field;
     int	v_flag;
{
  FILE			*fp;
  struct sort_struct	*sort_ptr;
  struct stat		stat_buff;
  static char		buff1[BUFF_SIZE];
  static char		buff2[BUFF_SIZE];
  static char		buff3[BUFF_SIZE];
  char			*ptr;
  static struct cpy_hdr	pick_fields[] = {
    {(char*)NULL,	buff2,	sizeof(buff2)},
  };
  short			year, month, date, day, hour, minute, second;
  register int		i, j;
  int			status;
  int			first;
  int			target;

  sprintf(buff1, "%s/%s/", mh_path, folder_name);
  ptr = buff1;
  while (*ptr) {
    ptr++;
  }
  if (field) {
    pick_fields[0].field_name = field;
  } else {
    pick_fields[0].field_name = DATE_FIELD;
  }
  if (!(sort_ptr = (struct sort_struct*)
	malloc(target_number * sizeof(struct sort_struct)))) {
    return(1);
  }
  for (i = 0; i < target_number; i++) {
    sprintf(ptr, "%d", target_ptr[i]);
    fp = fopen(buff1, "r");
    if (fp != (FILE*)NULL) {
      copy_mmh_fields(fp, pick_fields,
		      sizeof(pick_fields) / sizeof(struct cpy_hdr));
      fclose(fp);
    } else {
      buff2[0] = '\0';
    }
    sort_ptr[i].order = i;
    sort_ptr[i].year = sort_ptr[i].month = sort_ptr[i].date = sort_ptr[i].hour =
      sort_ptr[i].minute = sort_ptr[i].second = 0;
    if (buff2[0]) {
      if (field) {
	sort_ptr[i].second = atoi(buff2);
      } else {
	convert_date(buff2, &year, &month, &date, &day, &hour,
		     &minute, &second, buff3);
	sort_ptr[i].year   = year;
	sort_ptr[i].month  = month;
	sort_ptr[i].date   = date;
	sort_ptr[i].hour   = hour;
	sort_ptr[i].minute = minute;
	sort_ptr[i].second = second;
      }
    }
  }
  qsort(sort_ptr, target_number, sizeof(struct sort_struct), sort_compare);
  status = 0;
  first = 1;
  for (i = 0; i < target_number; i++) {
    for (j = 0; j < target_number; j++) {
      if (sort_ptr[j].order == i) {
	break;
      }
    }
    if (message_ptr == target_ptr) {
      target = j + 1;
    } else {
      target = target_ptr[j];
    }
    if (target_ptr[i] == target) {
      continue;
    }
    if (v_flag) {
      if (first) {
	first = 0;
	  printf("Renaming message chain from %d to %d.\n", target_ptr[0],
		 target_ptr[target_number - 1]);
      }
      printf("Message %d becomes message %d.\n", target_ptr[i], target);
    }
    for (j = i + 1; j < target_number; j++) {
      if (target_ptr[j] == target) {
	sprintf(ptr, "%d.SRT", target);
	strcpy(buff2, buff1);
	sprintf(ptr, "%d", target);
#ifdef	DEBUG
	printf("RENAME:%s->%s\n", buff1, buff2);
#endif	/* DEBUG */
	if (!stat(buff2, &stat_buff)) {
	  print_fatal("Program error.Illegal temporary message.");
	  j = -1;
	} else {
	  if (rename(buff1, buff2)) {
	    j = -1;
	  }
	}
        break;
      }
    }
    if (j < 0) {
      status = 1;
      continue;
    }
    sprintf(ptr, "%d", target);
    strcpy(buff2, buff1);
    sprintf(ptr, "%d.SRT", target_ptr[i]);
    if (stat(buff1, &stat_buff)) {
      sprintf(ptr, "%d", target_ptr[i]);
    }
#ifdef	DEBUG
    printf("RENAME:%s->%s\n", buff1, buff2);
#endif	/* DEBUG */
    if (!stat(buff2, &stat_buff)) {
      print_fatal("Program error.Illegal target message number.");
      status = 1;
    } else {
      if (rename(buff1, buff2)) {
	status = 1;
      }
    }
  }
  return(status);
}

/*
 * ե
 */
 
static int	sort_compare(data_ptr1, data_ptr2)
     struct sort_struct	*data_ptr1;
     struct sort_struct	*data_ptr2;
{
  register int	i;

  i = data_ptr1->year - data_ptr2->year;
  if (i) {
    return(i);
  }
  i = data_ptr1->month - data_ptr2->month;
  if (i) {
    return(i);
  }
  i = data_ptr1->date - data_ptr2->date;
  if (i) {
    return(i);
  }
  i = data_ptr1->hour - data_ptr2->hour;
  if (i) {
    return(i);
  }
  i = data_ptr1->minute - data_ptr2->minute;
  if (i) {
    return(i);
  }
  return(data_ptr1->second - data_ptr2->second);
}
